(use-modules
 (guix gexp)
 (guix packages)
 ((guix licenses) #:prefix license:)
 (guix download)
 (guix git-download)
 (guix build-system gnu)
 (gnu packages)
 (gnu packages autotools)
 (gnu packages guile)
 (gnu packages guile-xyz)
 (gnu packages pkg-config)
 (gnu packages texinfo))

(let ((%source-dir (dirname (current-filename))))
  (package
    (name "guile-nrepl")
    (version "0.1")
    (source (local-file %source-dir
                        #:recursive? #t
                        #:select? (git-predicate %source-dir)))
    (build-system gnu-build-system)
    (arguments
     (list
      #:make-flags
      #~(list "GUILE_AUTO_COMPILE=0")
      #:phases
      #~(modify-phases %standard-phases
          (delete 'strip)
          (add-before 'configure 'hall-build
            (lambda _
              (system* "hall" "build" "-x")))
          (add-after 'hall-build 'autoreconf
            (lambda _
              (system* "autoreconf" "-vif"))))))
    (native-inputs
     (list autoconf
           automake
           guile-hall
           pkg-config
           texinfo))
    (inputs (list guile-3.0))
    (propagated-inputs (list guile-config))
    (synopsis "???")
    (description "???")
    (home-page "???")
    (license license:gpl3+)))
